#Parse html pages to extract attributes. The html pages should be contained in "path" variable. Output would be in "data.json" file

import os
import sys
import re
import collections
from bs4 import BeautifulSoup
import json
f = open("data.json","w")
i = 0

def addAttr(name, type, list):
	oneAttr = collections.OrderedDict()
	oneAttr["name"] = name
	oneAttr["type"] = type
	list.append(oneAttr)

def parseHTML(htmldata, id, partial_attr_set):
	soup = BeautifulSoup(htmldata)
	data = collections.OrderedDict()
	data["id"] = id
	title = ''.join(soup.find_all(itemprop="name")[0].find(text=True)).strip();
	data["title"] = title
	authorlist = soup.findAll('ul',{'class':'contributors'})
	if authorlist:
		authors = ", ".join([x.string.strip() for x in authorlist[0].find_all('a')])
		data["authors"] = authors

	for i in soup.find_all('div',{'class':'product-details box'})[0].find_all("li"):
		strVal = " ".join([x.string.strip() for x in i.contents])
		attr = strVal.rsplit(":")[0].strip()
		value = strVal.rsplit(":")[1].strip()
                if "eBook" in value:
                  raise Exception("ebook")
                if "rank" in attr:
                  continue;
		partial_attr_set.add(attr)
		data[attr] = value

	price = soup.findAll('div',{'class':'price-info'})
	if price:
		price = price[0].prettify()
		price = re.findall("\$[0-9.]+",price)
		if price:
			price = price[0]
			data["price"] = price
	jd = json.dumps(data)
	jd = json.loads(jd,object_pairs_hook=collections.OrderedDict)
	return(jd)

path = r'/Users/wwu/Documents/CourseWork/CS784/Project/Crawl/scrapy/crawlBN/data'

jsondata = collections.OrderedDict()
jsondata["name"] = "B&N"
jsondata["description"] = "Database books from B&N"

tuples = list()

attr_set = set()
for dir_entry in os.listdir(path):
    dir_entry_path = os.path.join(path, dir_entry)
    if os.path.isfile(dir_entry_path):
        with open(dir_entry_path, 'r') as my_file:
            data = my_file.read()
        try:
            jd = parseHTML(data,i,attr_set)
            tuples.append(jd)
            i = i + 1
            if i %100 == 0:
            	print i
        except:
        	print dir_entry_path
attr = list()
addAttr("id","TEXT",attr)
addAttr("title","TEXT",attr)
addAttr("authors","TEXT",attr)
addAttr("price","TEXT",attr)

for x in attr_set:
	addAttr(x,"TEXT",attr)

jsondata["attributes"] = attr
jsondata["tuple"] = tuples


schema = collections.OrderedDict()
schema["table"] = jsondata

schema = json.dumps(schema)
schema = json.loads(schema,object_pairs_hook=collections.OrderedDict)
json.dump(schema,f,indent=4)
